package com.bonait.bnframework.business;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.constant.ConfigName;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_CLOUDDATA;
import com.bonait.bnframework.common.db.mode.BPA_PLCADDRESS;
import com.bonait.bnframework.common.db.mode.BPA_SYSTEMSET;
import com.bonait.bnframework.common.db.mode.Res_PLCADDRESS;
import com.bonait.bnframework.common.helper.ConfigUtil;
import com.bonait.bnframework.common.http.callback.json.JsonDialogCallback;
import com.bonait.bnframework.common.image.utils.LocalCacheUtils;
import com.bonait.bnframework.common.modbus.ModbusTcpHelper;
import com.bonait.bnframework.common.modbus.ModbusTcpServer;
import com.bonait.bnframework.common.model.ResAPI;
import com.bonait.bnframework.common.model.ResListAPI;
import com.bonait.bnframework.common.model.mode.CloudGood;
import com.bonait.bnframework.common.model.mode.DeviceInformation;
import com.bonait.bnframework.common.model.mode.DicModel;
import com.bonait.bnframework.common.model.mode.InPage;
import com.bonait.bnframework.common.model.mode.InputDev;
import com.bonait.bnframework.common.model.mode.OrganizeMode;
import com.bonait.bnframework.common.model.mode.ResALLData;
import com.bonait.bnframework.common.utils.NetworkUtils;
import com.google.gson.Gson;
import com.lzy.okgo.OkGo;
import com.lzy.okgo.model.HttpHeaders;
import com.lzy.okgo.model.Response;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import okhttp3.MediaType;
import okhttp3.RequestBody;


/**
 * 主函数进程
 * 主要进行配置文件-系统类
 */
public class ConfigData {
    //region 私有
    private static ConfigData mInstance; //实例变量设置私有，防止直接通过类名访问

    public static synchronized ConfigData getInstance() { //静态同步方法作为唯一的实例对象获取方式
        if (mInstance == null) {
            mInstance = new ConfigData();
        }
        return mInstance;
    }

    private ConfigData() { //默认构造函数私有，防止类外直接new创建对象
        Init();
    }
    //endregion

    //region 外部调用事件

    /**
     * 初始化
     */
    public void Init() {
        //1.加载系统设置
        LoadSystem();
        ToggleEnvironment();
        //2.加载配置
        LoadingPZ();
        //3.初始化业务
        //4.初始化日志上报adad
    }

    /**
     * 加载系统配置
     */
    public void LoadSystem() {
        ArrayList<BPA_SYSTEMSET> bpa_systemsets = QueryDB.GetSystemsetALL();
//        for(BPA_SYSTEMSET item:bpa_systemsets)
//        {
//            QueryDB.DeleteSystemset(item.id);
//        }
        for (int i = 0; i < 5; i++) {
            int ty = i;
            BPA_SYSTEMSET set = new BPA_SYSTEMSET();
            set.type = ty;
            switch (ty) {
                case 0:
                    set.value = ConfigName.getInstance().Environment;
                    break;
                case 1:
                    set.value = ConfigName.getInstance().Address;
                    break;
                case 2:
                    set.value = String.valueOf(ConfigName.getInstance().Post);
                    break;
                case 3:
                    set.value = ConfigName.getInstance().ClientAutoKey;
                    break;
                case 4:
                    set.value = ConfigName.getInstance().DeviceAutoKey;
                    break;
            }
            set.deviceID = ConfigName.getInstance().DeviceId;
            set.userID = ConfigName.getInstance().user.userID;
            BPA_SYSTEMSET find = null;
            for (BPA_SYSTEMSET item : bpa_systemsets) {
                if (item.type == ty) {
                    find = item;
                    break;
                }
            }
            if (find == null) {
                QueryDB.AddSystemset(set);
            }
        }
        bpa_systemsets = QueryDB.GetSystemsetALL();
        for (BPA_SYSTEMSET item : bpa_systemsets) {
            switch (item.type) {
                case 0:
                    ConfigName.getInstance().Environment = item.value;
                    break;
                case 1:
                    ConfigName.getInstance().Address = item.value;
                    break;
                case 2:
                    ConfigName.getInstance().Post = Integer.parseInt(item.value);
                    break;
                case 3:
                    ConfigName.getInstance().ClientAutoKey = item.value;
                    break;
                case 4:
                    ConfigName.getInstance().DeviceAutoKey = item.value;
                    break;
            }

        }
    }

    /**
     * 切换环境
     */
    public void ToggleEnvironment() {
        if (ConfigName.getInstance().Environment.equals("开发环境")) {
            ConfigName.getInstance().SaasAddress = "https://bpa.black-pa.com:21527/";
            ConfigName.getInstance().mqtt_userName = "emqx_u_block";
            ConfigName.getInstance().mqtt_passWord = "emqx_p_admin8765490789";
            ConfigName.getInstance().mqtt_ip = "10.2.1.21";
            ConfigName.getInstance().mqtt_post = 1883;
        } else if (ConfigName.getInstance().Environment.equals("测试环境")) {
            ConfigName.getInstance().SaasAddress = "https://bpa.black-pa.com:21528/";
            ConfigName.getInstance().mqtt_userName = "emqx_u_block";
            ConfigName.getInstance().mqtt_passWord = "emqx_p_admin8456765490789";
            ConfigName.getInstance().mqtt_ip = "111.9.47.105";
            ConfigName.getInstance().mqtt_post = 18889;
        } else if (ConfigName.getInstance().Environment.equals("正式环境")) {
            ConfigName.getInstance().SaasAddress = "https://witt.black-pa.com/";
            ConfigName.getInstance().mqtt_userName = "emqx_u_block";
            ConfigName.getInstance().mqtt_passWord = "emqx_p_admin3658765490789";
            ConfigName.getInstance().mqtt_ip = "47.108.65.220";
            ConfigName.getInstance().mqtt_post = 1883;
        }
    }

    /**
     * 加载配置
     */
    public void LoadingPZ() {
        //1.店铺配置
//        ConfigName.getInstance().Shop_Name = ConfigUtil.read(ConfigName.getInstance().dishesCon, "Shop_Name", ConfigName.getInstance().Shop_Name);
//        ConfigName.getInstance().AutKey = ConfigUtil.read(ConfigName.getInstance().dishesCon, "AutKey", ConfigName.getInstance().AutKey);
        //2.用户名称
        ConfigName.getInstance().user.account = ConfigUtil.read(ConfigName.getInstance().dishesCon, "username", ConfigName.getInstance().user.account);
        ConfigName.getInstance().user.pass = ConfigUtil.read(ConfigName.getInstance().dishesCon, "password", ConfigName.getInstance().user.pass);
        ConfigName.getInstance().IsUserDownOrder = ConfigUtil.read(ConfigName.getInstance().dishesCon, "IsUserDownOrder", ConfigName.getInstance().IsUserDownOrder);
        ConfigName.getInstance().Version = ConfigUtil.read(ConfigName.getInstance().dishesCon, "Version", ConfigName.getInstance().Version);
    }

    /**
     * 保存配置
     */
    public void SavePZ() {
        //1.店铺配置
//        ConfigUtil.write(ConfigName.getInstance().dishesCon,"Shop_Name", ConfigName.getInstance().Shop_Name);
//        ConfigUtil.write(ConfigName.getInstance().dishesCon,"AutKey", ConfigName.getInstance().AutKey);
        //2.用户信息
        ConfigUtil.write(ConfigName.getInstance().dishesCon, "username", ConfigName.getInstance().user.account);
        ConfigUtil.write(ConfigName.getInstance().dishesCon, "password", ConfigName.getInstance().user.pass);
        ConfigUtil.write(ConfigName.getInstance().dishesCon, "IsUserDownOrder", ConfigName.getInstance().IsUserDownOrder);
        ConfigUtil.write(ConfigName.getInstance().dishesCon, "IsUserDownOrder", ConfigName.getInstance().IsUserDownOrder);
        ConfigUtil.write(ConfigName.getInstance().dishesCon, "Version", ConfigName.getInstance().Version);
    }

    /**
     * 获取组织信息
     *
     * @param context
     */
    public void GetOrganize(Context context) {
        if (NetworkUtils.isNetworkConnected(context)) {

            //获取店铺信息
            OkGo.<ResAPI<OrganizeMode>>get(ConfigName.getInstance().SaasAddress + ConfigName.getInstance().GetStore + ConfigName.getInstance().ClientAutoKey)
                    .tag(context)
                    .execute(new JsonDialogCallback<ResAPI<OrganizeMode>>(context) {
                        @Override
                        public void onSuccess(Response<ResAPI<OrganizeMode>> response) {
                            ResAPI<OrganizeMode> organize = response.body();
                            if (organize.isSuccess) {
                                ConfigName.getInstance().organizeMode = organize.data;


                                OkGo.<ResAPI<DeviceInformation>>get(
                                                String.format(ConfigName.getInstance().SaasAddress + ConfigName.getInstance().GetDeviceInformation,
                                                        ConfigName.getInstance().organizeMode.id, ConfigName.getInstance().DeviceAutoKey))
                                        .tag(context)
                                        .execute(new JsonDialogCallback<ResAPI<DeviceInformation>>(context) {
                                            @Override
                                            public void onSuccess(Response<ResAPI<DeviceInformation>> response) {
                                                ResAPI<DeviceInformation> deviceInformation = response.body();
                                                if (deviceInformation.succeeded) {
                                                    ConfigName.getInstance().deviceInformation = deviceInformation.data;
                                                    if (ConfigName.getInstance().deviceInformation!=null)
                                                    {
                                                        ConfigName.getInstance().DeviceId=ConfigName.getInstance().deviceInformation.id;
                                                    }
                                                }
                                            }
                                        });
                            }
                        }
                    });


        }
    }

    /**
     * 同步云端数据
     */
    public void SyncDataInTheCloud(Context context)
    {
        //region 拉取物料数据
        OkGo.<ResAPI<ResALLData>>get(String.format(ConfigName.getInstance().SaasAddress + ConfigName.getInstance().GetBaseDataModel,
                                ConfigName.getInstance().organizeMode.id, ConfigName.getInstance().DeviceAutoKey))
                .tag(context)
                .headers(new HttpHeaders("TenantId",ConfigName.getInstance().organizeMode.companyId))
                .execute(new JsonDialogCallback<ResAPI<ResALLData>>(context) {
                    @Override
                    public void onSuccess(Response<ResAPI<ResALLData>> response) {
                        ResAPI<ResALLData> allDataResAPI = response.body();
                        if (allDataResAPI.succeeded && allDataResAPI.data!=null) {
                            BPA_CLOUDDATA data=new BPA_CLOUDDATA();

                            ArrayList<BPA_CLOUDDATA>  arrayList= QueryDB.GetClouddataALL();
                            for (BPA_CLOUDDATA item:arrayList)
                            {
                                QueryDB.DeleteClouddata(item);
                            }

                            if(allDataResAPI.data.batchingInfo!=null)
                            {
                                data=new BPA_CLOUDDATA();
                                data.id=java.util.UUID.randomUUID().toString();
                                data.name="物料集合";
                                data.text=new Gson().toJson(allDataResAPI.data.batchingInfo);
                                QueryDB.AddClouddata(data);
                            }

                            if(allDataResAPI.data.goodsTechnology!=null)
                            {
                                data=new BPA_CLOUDDATA();
                                data.id=java.util.UUID.randomUUID().toString();
                                data.name="工艺模型";
                                data.text=new Gson().toJson(allDataResAPI.data.goodsTechnology);
                                QueryDB.AddClouddata(data);
                            }

                            if(allDataResAPI.data.technologyAction!=null)
                            {
                                data=new BPA_CLOUDDATA();
                                data.id=java.util.UUID.randomUUID().toString();
                                data.name="工艺模型详细信息";
                                data.text=new Gson().toJson(allDataResAPI.data.technologyAction);
                                QueryDB.AddClouddata(data);
                            }

                            if(allDataResAPI.data.foodMenuInfo!=null)
                            {
                                data=new BPA_CLOUDDATA();
                                data.id=java.util.UUID.randomUUID().toString();
                                data.name="菜谱信息";
                                data.text=new Gson().toJson(allDataResAPI.data.foodMenuInfo);
                                QueryDB.AddClouddata(data);
                            }

                            if(allDataResAPI.data.goodsTypeInfo!=null)
                            {
                                data=new BPA_CLOUDDATA();
                                data.id=java.util.UUID.randomUUID().toString();
                                data.name="商品小类";
                                data.text=new Gson().toJson(allDataResAPI.data.goodsTypeInfo);
                                QueryDB.AddClouddata(data);
                            }

                            if(allDataResAPI.data.goodsParentTypeInfo!=null)
                            {
                                data=new BPA_CLOUDDATA();
                                data.id=java.util.UUID.randomUUID().toString();
                                data.name="商品大类";
                                data.text=new Gson().toJson(allDataResAPI.data.goodsParentTypeInfo);
                                QueryDB.AddClouddata(data);
                            }

                            if(allDataResAPI.data.goodsUintInfo!=null)
                            {
                                data=new BPA_CLOUDDATA();
                                data.id=java.util.UUID.randomUUID().toString();
                                data.name="商品单位";
                                data.text=new Gson().toJson(allDataResAPI.data.goodsUintInfo);
                                QueryDB.AddClouddata(data);
                            }

                        }
                    }
                });
        //endregion
    }

    /**
     * 获取所有商品信息
     * @param context
     */
    public void GetGevGood(Context context)
    {
        OkGo.<ResAPI<List<CloudGood>>>get(String.format(ConfigName.getInstance().SaasAddress + ConfigName.getInstance().GetGoods,
                        ConfigName.getInstance().organizeMode.id, ConfigName.getInstance().DeviceId))
                .tag(context)
                .headers(new HttpHeaders("TenantId",ConfigName.getInstance().organizeMode.companyId))
                .execute(new JsonDialogCallback<ResAPI<List<CloudGood>>>(context) {
                    @Override
                    public void onSuccess(Response<ResAPI<List<CloudGood>>> response) {
                        ResAPI<List<CloudGood>> allDataResAPI = response.body();
                        if (allDataResAPI.succeeded && allDataResAPI.data!=null) {


                        }
                    }
                });
    }

    /**
     * 增加本地图片
     */
    public void AddImage(Context context) {
        BitmapFactory.Options options = new BitmapFactory.Options();
        options.inSampleSize = 2;//宽高压缩为原来的1/2
        Bitmap bitmap1 = BitmapFactory.decodeResource(context.getResources(), R.mipmap.image1, options);
        Bitmap bitmap2 = BitmapFactory.decodeResource(context.getResources(), R.mipmap.image2, options);
        Bitmap bitmap3 = BitmapFactory.decodeResource(context.getResources(), R.mipmap.image3, options);
        Bitmap bitmap4 = BitmapFactory.decodeResource(context.getResources(), R.mipmap.image4, options);
        LocalCacheUtils localCacheUtils = new LocalCacheUtils();
        localCacheUtils.setBitmapToLocal("image1.png", bitmap1);
        localCacheUtils.setBitmapToLocal("image2.png", bitmap2);
        localCacheUtils.setBitmapToLocal("image3.png", bitmap3);
        localCacheUtils.setBitmapToLocal("image4.png", bitmap4);
    }

    /**
     * 还原PLC
     */
    public void RevertPLC()
    {
        try
        {
            ArrayList<BPA_PLCADDRESS>  arrayList= QueryDB.GetPlcaddressALL();
            for (BPA_PLCADDRESS item:arrayList)
            {
                QueryDB.DeletePlcaddress(item);
            }
            int k=1;
            for (Res_PLCADDRESS item:ConfigName.getInstance().PlcAddress_大炒)
            {
                BPA_PLCADDRESS plc=new BPA_PLCADDRESS();
                plc.name=item.name;
                plc.address=item.address;
                plc.isread=item.isread;
                plc.iswrite=item.iswrite;
                plc.sort=k;
                k++;
                QueryDB.AddPlcaddress(plc);
            }
        }catch (Exception ex)
        {

        }
    }
    //endregion

    //region PLC初始化

    /**
     * 连接PLC
     */
    public void ConnectPLC()
    {
        ConfigName.getInstance().PLC_Address.clear();
        ArrayList<BPA_PLCADDRESS> address=QueryDB.GetPlcaddressALL();
        for (BPA_PLCADDRESS item:address)
        {
            if(!item.address.isEmpty() && !item.address.equals("-------------"))
            {
                ConfigName.getInstance().PLC_Address.put(item.name,item);
            }
        }
        ExecuteTheRecipe.Listening();//启动数据监听
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    ModbusTcpServer.get().Connect();
                } catch (Exception e) {

                }
            }
        }).start();
    }

    /**
     * 关闭PLC
     */
    public void ColsePLC()
    {
        ModbusTcpHelper.get().release();//释放modbus
    }

    /**
     * PLC初始化完成时,需要注册的服务
     */
    public void PLC_Init()
    {


    }
    //endregion
}

