package com.bonait.bnframework.common.constant;

import android.content.Context;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.db.mode.BPA_PLCADDRESS;
import com.bonait.bnframework.common.db.mode.BPA_USER;
import com.bonait.bnframework.common.db.mode.Res_PLCADDRESS;
import com.bonait.bnframework.common.db.res.StatusMode;
import com.bonait.bnframework.common.model.AddrType;
import com.bonait.bnframework.common.model.mode.DeviceInformation;
import com.bonait.bnframework.common.model.mode.OrganizeMode;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.concurrent.ConcurrentHashMap;


/**
 * 配置文件
 */
public class ConfigName {
    //region 单例模式
    private static ConfigName  mInstance; //实例变量设置私有，防止直接通过类名访问

    private ConfigName() { //默认构造函数私有，防止类外直接new创建对象
    }

    public static synchronized ConfigName getInstance() { //静态同步方法作为唯一的实例对象获取方式
        if (mInstance==null) {
            mInstance = new ConfigName();
        }
        return mInstance;
    }
    //endregion

    //region 程序进入界面
    public Context dishesCon;
    public Context Home;
    //endregion

    //region SD卡路径设置
    /**
     * SD卡路径
     */
    public String sdCardPath;
    /**
     * 应用程序 Res 根路径
     */
    public String appResRoot;
    /**
     * Db文件路径
     */
    public static String dbPath = "";
    //endregion

    //region 店铺配置
    /**
     * 店铺名称
     */
    public String  Shop_Name="黑菠萝奶茶机";
    /**
     * 门店Id
     */
    public String ClientAutoKey="152";
    /**
     * 店铺设备号
     */
    public String DeviceAutoKey="146";
    /**
     * 设备id
     */
    public String DeviceId="29318217-838a-4572-982d-51773bef6249";
    //endregion

    //region MQTT配置中心
    /**
     * 用户名
     */
    public String mqtt_userName="emqx_u_block";
    /**
     * 密码
     */
    public String mqtt_passWord="emqx_p_admin8765490789";
    /**
     * ip地址
     */
    public String mqtt_ip="10.2.1.21";
    /**
     * post端口
     */
    public int mqtt_post=1883;
    /**
     * 订阅主题
     */
    public String mqtt_topic="DOWN/MORKT/BUSINESS/";
    public String mqtt_hearttopic="UP/MORKT/HEARTBEAT";
    //endregion

    //region 环境配置
    /**
     * 环境配置
     */
    public String Environment="开发环境";
    //endregion

    //region 登录信息
    /**
     * 用户信息
     */
    public BPA_USER user=new BPA_USER();
    //endregion

    //region 组织信息
    /**
     * 组织信息
     */
    public OrganizeMode organizeMode=null;
    /**
     * 设备信息
     */
    public DeviceInformation deviceInformation=null;
    //endregion

    //region 版本信息
    /**
     * 版本更新，当前版本
     */
    public String Version="1.0";
    //endregion

    //region 是否手动下单
    /**
     * 是否手动下单
     */
    public Boolean IsUserDownOrder=false;
    //endregion

    //region 系统设置表
    /**
     * 订单上报周期，默认一小时 *60
     */
    public int OrderPushTime=3600;
    /**
     * 料仓余量上报周期，默认10分钟 *60
     */
    public int SilosValuePushTime=600;
    /**
     * 其他传感器上报周期，默认10分钟 *60
     */
    public int OtherValuePushTime=600;
    /**
     * 管道排空周期，默认一小时 *60
     */
    public int PipeDrainCycleTime=3600;
    /**
     * 订单未制作超时规则，默认20分钟 *60
     */
    public int OrderTimeout=1200;
    /**
     * 料仓补料阈值，500g
     */
    public int SiloFeedThreshold=500;
    /**
     * 料仓告警阈值，50g
     */
    public int SiloAlarmThreshold=50;
    /**
     * 自动清洗时间，默认一小时 *60
     */
    public int AICleanTime=3600;
    //endregion

    //region PlC连接参数
    /**
     * Plc是否连接
     */
    public boolean PlcIsConnect=false;
    /**
     * Plc地址
     */
    public String Address="192.168.1.100";
    /**
     * Plc端口
     */
    public int Post=502;
    //endregion

    //region URL
    //Sass地址
    public String SaasAddress="http://order.test1.com";
    //public String SaasAddress="https://bpa.black-pa.com:21527";
    //public String SaasAddress="https://witt.black-pa.com";

    //获取店铺详细信息 Get
    public String GetStore="kitchen/api/StoreHelper/GetStoreInfoById?storeId=";
    //获取设备信息分页 Get
    public String GetDeviceInformation="kitchen/api/Device/GetDeviceInfo?storeId=%s&autoKey=%s";
    //获取 获取基础信息（所有物料信息、设备工序模型、菜谱列表、商品小类、商品大类、单位数据
    public String GetBaseDataModel="kitchen/api/CommInteface/GetBaseDataModel?storeId=%s&autoKey=%s";
    //获取 商品
    public String GetGoods="kitchen/api/CommInteface/GetDeviceGood?storeId=%s&deviceId=%s";
    //获取商品配方信息
    public String GetGoodsBom="kitchen/api/CommInteface/GetDeviceGoodBomTechnology?goodsId=%s";
    //上传商品
    public String UpdateGoods="kitchen/api/CommInteface/SendGoodsInfo";
    //版本更新
    public String UpdateVersion="http://111.9.47.105:18097/api/Version/GetLatest";
    //endregion

    //region PLC地址配置
    /**
     * PLC地址
     */
    public static ConcurrentHashMap<String, BPA_PLCADDRESS> PLC_Address = new ConcurrentHashMap<String, BPA_PLCADDRESS>();
    /**
     * 大炒基础PLC模型
     */
    public List<Res_PLCADDRESS> PlcAddress_大炒=new ArrayList<Res_PLCADDRESS>(){{

        //硬件设备 初始化
        add(new Res_PLCADDRESS("硬件设备","-------------",0,0));
        add(new Res_PLCADDRESS("初始化","M10.0",1,1));
        add(new Res_PLCADDRESS("停止"  ,"M10.1",1,1));
        add(new Res_PLCADDRESS("复位"  ,"M10.2",0,1));

        //搅拌模型
        add(new Res_PLCADDRESS("模型控制","-------------",0,0));
        add(new Res_PLCADDRESS("搅拌","M10.3",0,1));
        add(new Res_PLCADDRESS("搅拌速度","VW102",1,1));

        //翻转正转模型
        add(new Res_PLCADDRESS("翻转正转","M10.4",0,1));
        add(new Res_PLCADDRESS("转动速度","VW104",1,1));


        //翻转反转模型
        add(new Res_PLCADDRESS("翻转反转","M10.5",0,1));
        add(new Res_PLCADDRESS("转动速度","VW104",1,1));


        //加热模型
        add(new Res_PLCADDRESS("加热","M10.6",0,1));
        add(new Res_PLCADDRESS("加热功率","VW100",1,1));


        //抽水放水
        add(new Res_PLCADDRESS("炒锅抽水","M10.7",0,1));
        add(new Res_PLCADDRESS("炒锅放水","M11.0",0,1));


        //出菜模型
        add(new Res_PLCADDRESS("出菜","M11.5",0,1));


        //位置动作
        add(new Res_PLCADDRESS("原点位","M11.4",0,1));
        add(new Res_PLCADDRESS("投料位","M11.4",0,1));
        add(new Res_PLCADDRESS("倒菜位","M12.7",0,1));
        add(new Res_PLCADDRESS("抽料位","M11.7",0,1));
        add(new Res_PLCADDRESS("清洗位","M13.0",0,1));
        add(new Res_PLCADDRESS("炒菜位1","M12.0",0,1));
        add(new Res_PLCADDRESS("炒菜位2","M12.1",0,1));
        add(new Res_PLCADDRESS("炒菜位3","M12.2",0,1));

        add(new Res_PLCADDRESS("出餐启动","M11.5",0,1));
        add(new Res_PLCADDRESS("炒锅清洗","M11.6",0,1));

        //液体料模型
        add(new Res_PLCADDRESS("液体料","-------------",0,0));
        add(new Res_PLCADDRESS("料仓1下料","M11.1",0,1));
        add(new Res_PLCADDRESS("料仓2下料","M11.2",0,1));
        add(new Res_PLCADDRESS("料仓3下料","M11.3",0,1));
        add(new Res_PLCADDRESS("料仓1下料手动","M12.3",0,1));
        add(new Res_PLCADDRESS("料仓2下料手动","M12.4",0,1));
        add(new Res_PLCADDRESS("料仓3下料手动","M12.5",0,1));
        add(new Res_PLCADDRESS("开始校正","M12.6",0,1));
        add(new Res_PLCADDRESS("料仓1需求值","VW106",1,1));
        add(new Res_PLCADDRESS("料仓2需求值","VW108",1,1));
        add(new Res_PLCADDRESS("料仓3需求值","VW110",1,1));
        add(new Res_PLCADDRESS("校准时间","VW112",1,1));
        add(new Res_PLCADDRESS("料仓1校准值","VW114",1,1));
        add(new Res_PLCADDRESS("料仓2校准值","VW116",1,1));
        add(new Res_PLCADDRESS("料仓3校准值","VW118",1,1));


        //上下限
        add(new Res_PLCADDRESS("位置上下限","-------------",0,0));
        add(new Res_PLCADDRESS("原点位置下限","VD150",1,1));
        add(new Res_PLCADDRESS("原点位置上限","VD154",1,1));
        add(new Res_PLCADDRESS("洗锅位置下限","VD158",1,1));
        add(new Res_PLCADDRESS("洗锅位置上限","VD162",1,1));
        add(new Res_PLCADDRESS("倒菜位置下限","VD166",1,1));
        add(new Res_PLCADDRESS("倒菜位置上限","VD170",1,1));
        add(new Res_PLCADDRESS("抽调料位置下限","VD174",1,1));
        add(new Res_PLCADDRESS("抽调料位置上限","VD178",1,1));
        add(new Res_PLCADDRESS("1#炒制位置下限","VD182",1,1));
        add(new Res_PLCADDRESS("1#炒制位置上限","VD186",1,1));
        add(new Res_PLCADDRESS("2#炒制位置下限","VD190",1,1));
        add(new Res_PLCADDRESS("2#炒制位置上限","VD194",1,1));
        add(new Res_PLCADDRESS("3#炒制位置下限","VD198",1,1));
        add(new Res_PLCADDRESS("3#炒制位置上限","VD202",1,1));
        add(new Res_PLCADDRESS("炒锅工作范围下限","VD206",1,1));
        add(new Res_PLCADDRESS("炒锅工作范围上限","VD210",1,1));

        //反馈信号
        add(new Res_PLCADDRESS("反馈信号","-------------",0,0));
        add(new Res_PLCADDRESS("初始化完成","M40.0",1,0));
        add(new Res_PLCADDRESS("设备急停","M40.1",1,0));
        add(new Res_PLCADDRESS("原点位反馈","M40.2",1,0));
        add(new Res_PLCADDRESS("抽料位反馈","M40.3",1,0));
        add(new Res_PLCADDRESS("炒菜位1反馈","M40.4",1,0));
        add(new Res_PLCADDRESS("炒菜位2反馈","M40.5",1,0));
        add(new Res_PLCADDRESS("炒菜位3反馈","M40.6",1,0));
        add(new Res_PLCADDRESS("倒菜位反馈","M40.7",1,0));
        add(new Res_PLCADDRESS("投料位反馈","M41.0",1,0));
        add(new Res_PLCADDRESS("清洗位反馈","M41.1",1,0));
        add(new Res_PLCADDRESS("料仓1下料完成","M41.2",1,0));
        add(new Res_PLCADDRESS("料仓2下料完成","M41.3",1,0));
        add(new Res_PLCADDRESS("料仓3下料完成","M41.4",1,0));
        add(new Res_PLCADDRESS("炒锅清洗反馈","M41.5",1,0));
        add(new Res_PLCADDRESS("出餐启动反馈","M41.6",1,0));
        add(new Res_PLCADDRESS("炒锅倒菜减速位","M41.7",1,0));

        //检测信号
        add(new Res_PLCADDRESS("监测信号","-------------",0,0));
        add(new Res_PLCADDRESS("当前锅底温度","VD300",1,0));
        add(new Res_PLCADDRESS("炒锅搅拌转速","VD304",1,0));
        add(new Res_PLCADDRESS("当前加热档位","VD308",1,0));
        add(new Res_PLCADDRESS("炒锅当前电压","VD312",1,0));
        add(new Res_PLCADDRESS("炒锅当前电流","VD316",1,0));
        add(new Res_PLCADDRESS("炒锅当前功率","VD320",1,0));
        add(new Res_PLCADDRESS("搅拌频率","VW324",1,0));
        add(new Res_PLCADDRESS("搅拌电机电流","VW326",1,0));
        add(new Res_PLCADDRESS("搅拌电机电压","VW328",1,0));
        add(new Res_PLCADDRESS("搅拌变频器温度","VW330",1,0));
        add(new Res_PLCADDRESS("翻转频率","VW332",1,0));
        add(new Res_PLCADDRESS("翻转电机电流","VW334",1,0));
        add(new Res_PLCADDRESS("翻转电机电压","VW336",1,0));
        add(new Res_PLCADDRESS("翻转变频器温度","VW338",1,0));
        add(new Res_PLCADDRESS("编码器当前位值","VD340",1,0));

        //状态上报
        add(new Res_PLCADDRESS("状态上报","-------------",0,0));
        add(new Res_PLCADDRESS("搅拌电机","VW350",1,0));
        add(new Res_PLCADDRESS("翻转电机","VW352",1,0));
        add(new Res_PLCADDRESS("炒锅","VW354",1,0));

    }};
    /**
     * 速度
     */
    public ConcurrentHashMap<String,Integer> StirringSpeed=new ConcurrentHashMap<String,Integer>()
    {{
        put("停止",0);
        put("最低",10);
        put("低速",20);
        put("中速",30);
        put("高速",40);
        put("最高",50);
        put("极高",60);
    }};
    /**
     * 挡位 功率
     */
    public ConcurrentHashMap<String,Integer> HeatingGear=new ConcurrentHashMap<String,Integer>()
    {{
        put("停止",0);
        put("一档",2);
        put("二档",4);
        put("三档",6);
        put("四档",8);
        put("五档",10);
    }};
    /**
     * 状态上报信息
     */
    public List<StatusMode> statusModes=new ArrayList<StatusMode>(){{

        //硬件设备 初始化
        add(new StatusMode("急停",false,R.mipmap.jiting,R.mipmap.jiting,0));
        add(new StatusMode("炒锅正限位报警",false,R.mipmap.cg_sxw,R.mipmap.cg_sxw,2));
        add(new StatusMode("炒锅负限位报警",false,R.mipmap.cgxxw,R.mipmap.cgxxw,3));
        add(new StatusMode("编码器通讯异常",false,R.mipmap.bmq,R.mipmap.bmq,4));
        add(new StatusMode("搅拌电机变频器通讯异常",false,R.mipmap.bpq,R.mipmap.bpq,6));
        add(new StatusMode("翻转电机变频器通讯异常",false,R.mipmap.bpq,R.mipmap.bpq,7));
    }};

    /**
     * 状态上报信息
     */
    public ConcurrentHashMap<Integer,String> statusModes_电机=new ConcurrentHashMap<Integer,String>()
    {{
        put(0 ,"无故障");
        put(1 ,"过电流");
        put(2 ,"过电压");
        put(3 ,"IGBT过热");
        put(4 ,"");
        put(5 ,"变频器过负载");
        put(6 ,"电机过负载");
        put(7 ,"过转矩");
        put(8 ,"外部异常");
        put(9 ,"加速中过电流");
        put(10,"减速中过电流");
        put(11,"恒速中过电流");
        put(12,"");
        put(13,"电压不足");
        put(14,"输入电压缺相");
        put(15,"");
        put(16,"不适用自动加减速设定");
        put(17,"软件参数密码保护");
        put(18,"CPU写入异常");
        put(19,"CPU读取异常");
        put(20,"端子保护线路异常");
        put(21,"0V保护线路异常");
        put(22,"");
        put(23,"");
        put(24,"U相硬件异常");
        put(25,"V相硬件异常");
        put(26,"W相硬件异常");
        put(27,"DC，bus 硬件异常");

    }};
    //endregion
}



//配方信息
//{
//        "statusCode": 200,
//        "data": {
//        "bomInfo": [
//        {
//        "name": "爆炒肥肠",
//        "code": "10005",
//        "isMain": true,
//        "autoKey": 1099,
//        "bomInfo": null,
//        "sort": 2,
//        "groupId": "4cc8935c-9519-4a3c-a2fd-b49ca54f6f0d",
//        "status": 0,
//        "isDeleted": 0,
//        "deleteAt": null,
//        "deleteBy": null,
//        "updateAt": null,
//        "updateBy": null,
//        "createAt": "2023-07-10 16:11:41",
//        "createBy": "af27ebbd-5c1a-441f-8e26-cf6cc1352349",
//        "id": "5c4f80d9-13f3-4dcf-9cca-db4d37ffc9d0"
//        }
//        ],
//        "bomTechnologyActionInfo": [
//        {
//        "stepName": "热油",
//        "actionJson": "[{\"TechnologyactionId\":\"a82d2621-7016-4240-b5d5-7d5e41fb4d22\",\"ActionName\":\"加热功率\",\"ActionValue\":\"三档\",\"BatchingId\":\"\"},{\"TechnologyactionId\":\"df17c307-8f15-4d20-b497-61caf5668270\",\"ActionName\":\"热油(克)\",\"ActionValue\":333,\"BatchingId\":\"\"}]",
//        "bomId": "5c4f80d9-13f3-4dcf-9cca-db4d37ffc9d0",
//        "isBatch": false,
//        "chnologyId": "f9ca0cff-ba94-4036-88f4-a5d05f8165e6",
//        "createAt": "2023-07-11 17:47:28",
//        "groupId": "4cc8935c-9519-4a3c-a2fd-b49ca54f6f0d",
//        "isDeleted": 0,
//        "sort": 6,
//        "id": "7c3a5fe9-f1c6-4578-b6a8-a09006740d69"
//        },
//        {
//        "stepName": "液体料",
//        "actionJson": "[{\"TechnologyactionId\":\"10915b41-268e-4d04-b259-8e4c5f65bbda\",\"ActionName\":\"酱油\",\"ActionValue\":\"10\",\"BatchingId\":\"210f346d-8b79-4059-a991-b22391e5193f\"},{\"TechnologyactionId\":\"897bc239-ba70-4cde-bd99-c4bb14219b04\",\"ActionName\":\"盐水\",\"ActionValue\":\"20\",\"BatchingId\":\"33a529a3-de63-49c0-aed0-ea83e852050b\"}]",
//        "bomId": "5c4f80d9-13f3-4dcf-9cca-db4d37ffc9d0",
//        "isBatch": true,
//        "chnologyId": "315b149d-53bd-4fa0-9694-bf1d47ef9ba3",
//        "createAt": "2023-07-11 17:36:46",
//        "groupId": "4cc8935c-9519-4a3c-a2fd-b49ca54f6f0d",
//        "isDeleted": 0,
//        "sort": 5,
//        "id": "a9e95580-89ba-400c-a91f-53fefbabb627"
//        }
//        ]
//        },
//        "succeeded": true,
//        "errors": null,
//        "extras": null,
//        "timestamp": 1689070602181
//        }



//
//{
//        "goodsInfo": {
//        "id": "string",
//        "isDeleted": 0,
//        "deleteAt": "2023-07-11T10:17:20.548Z",
//        "deleteBy": "string",
//        "updateAt": "2023-07-11T10:17:20.548Z",
//        "updateBy": "string",
//        "createAt": "2023-07-11T10:17:20.548Z",
//        "createBy": "string",
//        "status": 0,
//        "groupId": "string",
//        "goods_Name": "string",
//        "goods_TypeID": "string",
//        "goods_Descritption": "string",
//        "goods_ImgUrl": "string",
//        "goods_ImgMode": 0,
//        "goods_Sort": 0,
//        "goods_Enable": 0,
//        "deleteUpdateTime": "2023-07-11T10:17:20.548Z",
//        "key": "string",
//        "code": "string",
//        "price": 0,
//        "tasteID": "string",
//        "parentTypeID": "string",
//        "vipPrice": 0,
//        "goodsAttribute": 0,
//        "goodsUintId": "string",
//        "isWeigh": true,
//        "autoKey": 0
//        },
//        "bomInfo": {
//        "bomType": "string",
//        "name": "string",
//        "code": "string",
//        "isMain": true,
//        "autoKey": 0,
//        "bomInfo": "string",
//        "sort": 0
//        },
//        "bomTechnologyActionInfo": [
//        {
//        "id": "string",
//        "stepName": "string",
//        "actionJson": "string",
//        "bomId": "string",
//        "isBatch": true,
//        "chnologyId": "string",
//        "createAt": "2023-07-11T10:17:20.548Z",
//        "groupId": "string",
//        "isDeleted": 0,
//        "sort": 0
//        }
//        ],
//        "foodMenuId": "string",
//        "storeId": "string"
//        }