package com.bonait.bnframework.modules.home.fragment.mode;

import android.content.Context;
import android.text.InputType;
import android.util.AttributeSet;
import android.view.LayoutInflater;
import android.view.View;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.Switch;
import android.widget.TextView;

import androidx.annotation.Nullable;

import com.bonait.bnframework.R;
import com.bonait.bnframework.business.ExecuteTheRecipe;
import com.bonait.bnframework.common.db.QueryDB;
import com.bonait.bnframework.common.db.mode.BPA_PLCADDRESS;
import com.bonait.bnframework.common.utils.AlertDialogUtils;
import com.bonait.bnframework.common.utils.ToastUtils;
import com.qmuiteam.qmui.widget.dialog.QMUIDialog;
import com.qmuiteam.qmui.widget.dialog.QMUIDialogAction;

import butterknife.BindView;
import butterknife.ButterKnife;
import butterknife.OnClick;

/**
 * PLC控制
 */
public class fragment_plc_control extends LinearLayout {
    @BindView(R.id.name)
    TextView name;
    @BindView(R.id.name_PLC)
    TextView name_PLC;//分组

    @BindView(R.id.edittext_plc)
    EditText edittext_plc;//输入文本
    @BindView(R.id.wenben)
    LinearLayout wenben;
    @BindView(R.id.kaiguan)
    RelativeLayout kaiguan;

    @BindView(R.id.zhidu)
    RelativeLayout zhidu;

    @BindView(R.id.update_plc)
    Button update_plc;//下发按钮

    @BindView(R.id.control_switch)
    Switch control_switch;//下发按钮

    @BindView(R.id.text_wb)
    TextView text_wb;//分组
    private View root;
    public fragment_plc_control(Context context, @Nullable AttributeSet attrs, BPA_PLCADDRESS _model) {
        super(context, attrs);
        root= LayoutInflater.from(context).inflate(R.layout.fragment_item_plc_control, this);
        ButterKnife.bind(this, root);
        model=_model;
        Init();
    }
    public void Init()
    {
        if (model.address.equals("-------------"))
        {
            name.setText(model.name+"：");
            wenben.setVisibility(View.GONE);
            kaiguan.setVisibility(View.GONE);
            zhidu.setVisibility(View.GONE);
        }else
        {
            name_PLC.setText(model.name);
            if(model.iswrite==1)
            {
                zhidu.setVisibility(View.GONE);
                if(model.address.startsWith("M"))//开关
                {
                    wenben.setVisibility(View.GONE);
                    kaiguan.setVisibility(View.VISIBLE);
                    if(model.isread==1)
                    {
                        Object val= ExecuteTheRecipe.ListeningValue.get(model.name);
                        if(val!=null)
                        {
                            control_switch.setChecked((boolean)val);
//                            if ((boolean)val)
//                            {
//                                control_switch.setText("打开");
//                            }else
//                            {
//                                control_switch.setText("关闭");
//                            }
                        }
                    }
                } else //文本
                {
                    wenben.setVisibility(View.VISIBLE);
                    kaiguan.setVisibility(View.GONE);
                    if(model.isread==1)
                    {
                        Object val= ExecuteTheRecipe.ListeningValue.get(model.name);
                        if(val!=null)
                        {
                            String str=String.valueOf(val);
                            edittext_plc.setText(str.toCharArray(), 0, str.length());
                        }
                    }
                }
            }else //只读
            {
                zhidu.setVisibility(View.VISIBLE);
                wenben.setVisibility(View.GONE);
                kaiguan.setVisibility(View.GONE);
                Object val= ExecuteTheRecipe.ListeningValue.get(model.name);
                if(val!=null)
                {
                    text_wb.setText(val+"");
                }
            }
        }


        control_switch.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View view) {
                boolean ischick= control_switch.isChecked();
//                if (ischick)
//                {
//                    control_switch.setText("打开");
//                }else
//                {
//                    control_switch.setText("关闭");
//                }

                ExecuteTheRecipe.WritePLC(model.name,ischick,null);
                ToastUtils.info("写入地址:"+model.address+"成功！状态:"+(ischick?"打开":"关闭"));

            }
        });
    }
    public BPA_PLCADDRESS model=null;

    @OnClick({R.id.update_plc})
    public void onViewClicked(View view) {
        switch (view.getId()) {
            case R.id.update_plc:
                String text=edittext_plc.getText().toString();
                if(text.isEmpty())
                {
                    ToastUtils.warning("输入信息不能为空！");
                    return;
                }

                if(model.address.startsWith("VW"))
                {
                    Short val=Short.parseShort(text);
                    ExecuteTheRecipe.WritePLC(model.name,val,null);
                }else if(model.address.startsWith("VD"))
                {
                    int val=Integer.parseInt(text);
                    ExecuteTheRecipe.WritePLC(model.name,val,null);
                }else
                {
                    Short val=Short.parseShort(text);
                    ExecuteTheRecipe.WritePLC(model.name,val,null);
                }
                ToastUtils.info("写入地址:"+model.address+"成功！");
                break;

        }
    }
}